import java.io.*;
import java.util.Vector;
import javax.microedition.io.Connector;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.Phone;
import org.xmlpull.v1.XmlPullParserException;

public class IContactApp extends IApplication 
    implements SoftKeyListener, ComponentListener {

    Vector db = new Vector(); // ContactXML  URL f[x[X
    ContactItem item; // ContactXMLItem ̃f[^(\ڂ̂)
    ContactItemParser parser = new ContactItemParser();

    boolean deleteMode = false;

    Panel mainPanel;
    Panel docPanel;
    ListBox contactList;
    ListBox phoneList;
    ListBox webList;
    ListBox emailList;
    MediaImage portrait;
    
    ////// ubN}[N@\֌W
    InputStream getDBInputStream() throws IOException {
	return Connector.openInputStream("scratchpad:///0");
    }

    OutputStream getDBOutputStream() throws IOException {
	return Connector.openOutputStream("scratchpad:///0");
    }

    void loadDB() {
	/* DB format:   db := line*
	 *            line := name TAB url NL
	 */
	InputStreamReader reader = null;
	try {
	    reader = new InputStreamReader(getDBInputStream(), "SJIS");
	    StringBuffer buffer = new StringBuffer();
	    int c; 
	    while ((c = reader.read()) != -1 && c != 0) {
		if (c == '\n') {
		    String line = buffer.toString();
		    Entry ent = new Entry(null, null);
		    int delimPos = line.indexOf('\t');
		    ent.name = line.substring(0, delimPos);
		    ent.url = line.substring(delimPos + 1);
		    db.addElement(ent);
		    buffer.setLength(0);
		} else {
		    buffer.append((char)c);
		}
	    }
	} catch(Exception e) {
	    error("f[^x[X̓ǂݍ݂Ɏs܂");
	} finally {
	    if (reader != null) {
		try {
		    reader.close();
		} catch (Exception e) {
		}
	    }
	}
    }

    void saveDB() {
	OutputStreamWriter writer = null;
	try {
	    writer = new OutputStreamWriter(getDBOutputStream(), "SJIS");
	    for (int i=0; i < db.size(); i++) {
		Entry ent = getEntryAt(i);
		String line = ent.name + "\t" + ent.url + "\n";
		writer.write(line);
	    }
	    writer.write(0); // write terminater char.
	} catch(IOException ie) {
	    //
	} finally {
	    if (writer != null) {
		try { writer.close(); } catch (Exception e) {}
	    }
	}
    }
	
    Entry getEntryAt(int index) {
	return (Entry)db.elementAt(index);
    }

    void addEntry(String name, String url) {
	db.addElement(new Entry(name, url));
	contactList.append(name);
    }

    void removeEntryAt(int index) { 
	db.removeElementAt(index);
	refreshContactList();
    }

    void refreshContactList() {
	contactList.removeAll();
	for (int i=0; i<db.size(); i++) {
	    contactList.append(getEntryAt(i).name);
	}
    }

    boolean containsURL(String url) {
	for (int i=0; i<db.size(); i++) {
	    if (url.equals(getEntryAt(i).url)) {
		return true;
	    }
	}
	return false;
    }

    ////// r[A@\֌W
    String getProxyURL(String url) {
	String srcURL = getSourceURL();
	if (!srcURL.startsWith("http:")) {
	    srcURL = "http://www.horobi.com/i/contact/";
	}
	return srcURL + "get.cgi?url=" + url;
    }

    void parseDocument(String url) throws Exception {
	InputStream is = null;
	HttpConnection conn = null;
	if(url.startsWith("http:")) {
	    String serverURL = getProxyURL(url);
	    conn = (HttpConnection) Connector.open(serverURL,
						   Connector.READ, true);
	    conn.setRequestMethod(HttpConnection.GET);
	    conn.connect();
	    is = conn.openInputStream();
	} else {
	    is = Connector.openInputStream(url);
	}
	parser.setItem(item);
	parser.parse(is);
	if (is != null) {
	    is.close();
	}
	if (conn != null) {
	    conn.close();
	}
    }

    void view(String url, boolean needRegister, boolean needReload) {
	if (!needReload && item != null && docPanel != null 
	    && url.equals(item.location)) {
	    // OɊJh͍ēǂݍ݂Ȃ([hȊO)
	    Display.setCurrent(docPanel);
	    return;
	}
	if (portrait != null) {
	    // C[W̔j
	    portrait.unuse();
	    portrait.dispose();
	    portrait = null;
	}
	docPanel = new Panel();
	docPanel.setSoftKeyListener(this);
	docPanel.setComponentListener(this);
	docPanel.setSoftLabel(Frame.SOFT_KEY_1, "߂");
	docPanel.setSoftLabel(Frame.SOFT_KEY_2, "-");
	docPanel.setTitle("ǂݍݒ...");
	Display.setCurrent(docPanel);

	// ACẽp[X
	item = new ContactItem();
	item.location = url;
	try {
	    parseDocument(url);
	    if (needRegister && !containsURL(url)) {
		//  URL Gg[ȂȂo^
		addEntry(item.name, url);
	    }
	} catch (XmlPullParserException pe) {
	    error("p[XG[(" + pe + ")");
	    return;
	} catch (IOException ie) {
	    error("I/O G[(" + ie + ")");
	    return;
	} catch (Exception e) {
	    error("s̃G[(" + e + ")");
	    return;
	}

	docPanel.setTitle(item.name);
	buildView();
	Display.setCurrent(docPanel);
    }
    void buildView() {
	if (item.imageURL != null) {
	    // |[g[g̕\
	    portrait = MediaManager.getImage(getProxyURL(item.imageURL));
	    ImageLabel label = null;
	    try {
		portrait.use();
		label = new ImageLabel(portrait.getImage());
	    } catch (ConnectionException ce) {
		// TODO: G[摜̃Zbg
	    }
	    docPanel.add(label);
	}

	docPanel.add(new Label(item.name));
	if (item.pronunciation != null) {
	    docPanel.add(new Label(item.pronunciation));
	}	
	buildTextViews(3, item.occupation);
	phoneList = buildListView("db:", 3, item.phones);
	webList = buildListView("Web:", 3, item.webs);
	emailList = buildListView("E-Mail:", 3, item.emails);
	docPanel.add(new Label("Z:", Label.LEFT));
	buildTextViews(5, item.address);
    }

    ListBox buildListView(String label, int max, Vector vector) {
	if(vector.size() > 0) {
	    docPanel.add(new Label(label, Label.LEFT));
	    int listSize = vector.size();
	    listSize = (listSize > max) ? max : listSize;
	    ListBox list = new ListBox(ListBox.SINGLE_SELECT, listSize);
	    for (int i=0; i<vector.size(); i++) {
		list.append((String)vector.elementAt(i));
	    }
	    docPanel.add(list);
	    return list;
	}
	return null;
    }
    void buildTextViews(int lines, Vector vector) {
	if (vector.size() > 0) {
	    for (int i=0; i<item.address.size(); i++) {
		String text = (String)vector.elementAt(i);
		TextBox box = new TextBox(text, 20, lines,
					  TextBox.DISPLAY_ANY);
		box.setEditable(false);
		docPanel.add(box);
	    }
	}
    }

    void error(String msg) {
	Dialog error = new Dialog(Dialog.DIALOG_ERROR, "G[");
	error.setText(msg);
	error.show();
    }

    //// extends IApplication
    public void start() {
	mainPanel = new Panel();
	Display.setCurrent(mainPanel);

	loadDB();

	mainPanel.setTitle("R^NgXg");
	mainPanel.setSoftKeyListener(this);
	mainPanel.setComponentListener(this);
	mainPanel.setSoftLabel(Frame.SOFT_KEY_1, "I");
	mainPanel.setSoftLabel(Frame.SOFT_KEY_2, "폜");

	contactList = new ListBox(ListBox.SINGLE_SELECT, 7);
	//contactList.setBackground(Graphics.WHITE);
	refreshContactList();
	mainPanel.add(contactList);

	int lt = getLaunchType();
	if (lt == LAUNCHED_FROM_BROWSER || lt == LAUNCHED_FROM_MAILER) {
	    String url = getParameter("url");
	    if (url != null) {
		view(url, true, false);
	    } else {
		Display.setCurrent(mainPanel);
	    }
	} else {
	    Display.setCurrent(mainPanel);
	}
    }

    //// implements SoftKeyListener
    public void softKeyPressed(int key) {
	Frame f = Display.getCurrent();
	if (f == mainPanel) {
	    if (key == Frame.SOFT_KEY_1) {
		if (!deleteMode) {
		    saveDB();
		    terminate();
		}
	    } else if (key == Frame.SOFT_KEY_2) {
		if (deleteMode) {
		    deleteMode = false;
		    mainPanel.setTitle("R^NgXg");
		    mainPanel.setSoftLabel(Frame.SOFT_KEY_1, "I");
		    mainPanel.setSoftLabel(Frame.SOFT_KEY_2, "폜");
		} else {
		    deleteMode = true;
		    mainPanel.setTitle("폜[h");
		    mainPanel.setSoftLabel(Frame.SOFT_KEY_1, "");
		    mainPanel.setSoftLabel(Frame.SOFT_KEY_2, "߂");
		}
	    }
	} else if (f == docPanel) {
	    if (key == Frame.SOFT_KEY_1) {
		// ߂
		Display.setCurrent(mainPanel);
	    } else if (key == Frame.SOFT_KEY_2) {
		// [h
		view(item.location, true, true);
	    }
	}
    }

    public void softKeyReleased(int key) {}

    //// implements ComponentListener
    public void componentAction(Component source, int type, int param) {
	if (source == contactList && type == SELECTION_CHANGED) {
	    int i = contactList.getSelectedIndex();
	    if (i < 0) return;
	    if (deleteMode) {
		Dialog confirm = new Dialog(Dialog.DIALOG_YESNO ,"mF");
		confirm.setText("IACe폜܂?");
		if(confirm.show() == Dialog.BUTTON_YES) {
		    System.out.println("remove");
		    removeEntryAt(i);
		}
	    } else {
		view(getEntryAt(i).url, false, false);
	    }
	} else if (source == phoneList && type == SELECTION_CHANGED) {
	    int i = phoneList.getSelectedIndex();
	    if (i < 0) return;
	    Phone.call((String)item.phones.elementAt(i));
	} else if (source == webList && type == SELECTION_CHANGED) {
	    int i = webList.getSelectedIndex();
	    if (i < 0) return;
	    String args[] = { (String)item.webs.elementAt(i) };
	    // AvIĂ܂̂DBZ[uB
	    saveDB();
	    launch(LAUNCH_BROWSER, args);
	}
    }
}

class Entry {
    public String name;
    public String url;

    Entry(String theName, String theURL) {
	name = theName;
	url = theURL;
    }
}
